/*
Constants, global variables and function prototypes for skymapl
 *** In all of the midi_b routines the variable "jemx" has the value 0 for JEM-X1 and 1 for JEM-X2 
*/

#define FOV_rad		127		/* radius of FOV in pixels (defines the pixel size - the FOV is given) */
#define skyxdim		(2*FOV_rad+1)	/* X dimension of the region of interest (2*FOV_radius + 1 = full field) */
#define skyydim		(2*FOV_rad+1)	/* Y dimension of the region of interest (2*FOV_radius + 1 = full field) */
#define skydim		(skyxdim * skyydim)
#define byt_max		240000000	/* max limit for size of 'd_allow' list (bytes) */
#define detdim		65536		/* the detector is divided into 256*256 pixels */

extern int d_allow_p[detdim], FOV_radius, o_ctrl;
extern short d_allow_l[detdim];
extern unsigned d_allow_st[detdim];
extern unsigned char d_allow[byt_max];

   	/* begin parameters to be updated through alignment.dat */ 
extern double coll_pitch;
extern double coll_h;       /* height of collimator */
extern double coll_w;       /* halfthickness of lamellae */
extern double coll_r;	/* collimator radius */ 
extern double mask_r;	/* radius of coded mask pattern */
extern double mask_height;
extern double hexa_dim;     /* flat-to-flat dimension of the mask elements */
extern double struc_h1;
extern double struc_h2;
extern double alfa;
extern double beta;
extern double gammav;
extern double  xshi;
extern double  yshi;
extern double c_tiltx;
extern double c_tilty;
extern double coll_wb;
extern double coll_corner;

extern double  indep; 
extern int FOV_radius;
extern double coll_curv;
extern double mask_scale;
extern double x_rms[5]; 	/* position determination uncertainty at the boundaries*/
extern double rmsfact;
extern double y_rms[5]; 	/* the values given here are default values */

extern double scaleX;
extern double scaleY;
extern double phase2;
extern double  x2x;
extern double  y2y;
extern double  offX;
extern double  offY;
extern double  offQ;
extern double  offR; 
	/* end parameters to be updated through alignment.dat */ 


extern double cosal, sinal, cosbe, sinbe, cosga, singa;
extern double r_sky, c_fact, c_factb, m_fact, c0_fact, cot60, rsin60;
extern double collp30;	/* 30 times the collimator pitch */
extern double coll_r2, mask_r;

extern int njwmask[200][200]; 

extern char sweethome[];
extern double pi, twopi, gtorad; 
extern double parameters[20];

int struchk(double xm, double ym, double x_det, double y_det, int last);



